/* 
 * Copyright (C) 2017 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/gpl-3.0.txt
 *
 */
package com.frojasg1.textcrypt.application;

import com.frojasg1.textcrypt.startapp.StartApplication;


/**
 *
 * @author Usuario
 */
public class Main
{
	protected static final String APPLICATION_NAME = "TextCrypt";
//	protected static Splash _splash = null;

	public static String getApplicationName()
	{
		return( APPLICATION_NAME );
	}

	public static void main( String[] args )
	{
		StartApplication obj = new StartApplication();

		obj.startApplication();
	}
	
/*
	public static void main( String[] args )
	{
		try
		{
			javax.swing.UIManager.setLookAndFeel( new ToolTipLookAndFeel() );
		} catch (javax.swing.UnsupportedLookAndFeelException ex) {
			java.util.logging.Logger.getLogger(MainWindow.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
		}

		try
		{
	*/
			/*
				Result of this parameter for different operating systems.
				O.S. name:Linux
				O.S. name:Mac OS X
				O.S. name:Windows 8
			*/
/*			System.out.println( "O.S. name:" + System.getProperty("os.name") );
			System.out.println( "O.S. arch:" + System.getProperty("os.arch") );
			System.out.println( "O.S. version:" + System.getProperty("os.version") );

			OpenConfiguration oc = new OpenConfiguration( null );
			_splash = Splash.instance();
			_splash.setCurrentActivityFromLabel( Splash.CONF_OPENING_CONFIGURATION );

			java.awt.EventQueue.invokeLater(new Runnable()  {
				public void run() {
					try
					{
						_splash.setVisible( true );
					}
					catch( Throwable th )
					{
						th.printStackTrace();
					}
				}
			});

			try
			{
				Thread.sleep( 200 );
			}
			catch( Throwable th )
			{
				th.printStackTrace();
			}

			if( ApplicationConfiguration.instance().getLicensesHaveBeenAccepted() )
			{
				_splash.setProgress( 50 );
				_splash.setCurrentActivityFromLabel( Splash.CONF_CREATING_MAIN_WINDOW );
			}
			else
			{
				_splash.setProgress( 33 );
				_splash.setCurrentActivityFromLabel( Splash.CONF_SHOWING_LICENSES );

				LicenseJDialog licenseJDialog = new LicenseJDialog( (JDialog)null, ApplicationConfiguration.instance() );
				licenseJDialog.setVisible( true );

				ApplicationConfiguration.instance().M_saveConfiguration();
				if( !licenseJDialog.getLicensesHaveBeenAcceptedAndWeHaveToStart() )
				{
					System.exit(1);
				}

				licenseJDialog.closeAndReleaseWindow();

				_splash.setCurrentActivityFromLabel( Splash.CONF_CREATING_MAIN_WINDOW );
				_splash.setProgress( 66 );
			}

//			oc.importConfigurationIfNecessary();

			MainWindowLauncher launcher = new MainWindowLauncher();

			// We open the rest of configuration files, depending on the language, which will create the configuration application folder.
			oc.openOtherConfiguration();

			try
			{
				Thread.sleep( 300 );
			}
			catch( Throwable th )
			{
				th.printStackTrace();
			}

			_splash.setProgress( 100 );

			java.awt.EventQueue.invokeLater( launcher );

			try
			{
				Thread.sleep( 300 );
			}
			catch( Throwable th )
			{
				th.printStackTrace();
			}

			if( launcher.hasExceptionBeenThrown() )
			{
				DesktopDialogsWrapper.instance().showMessageDialog(null,
							_splash.getInternationalString( _splash.CONF_PROBLEM_LAUNCHING_THE_APPLICATION ),
							"ERROR", DialogsWrapper.ERROR_MESSAGE );

				System.exit(1);
			}

			Splash.free();
			_splash = null;
		}
		catch( Throwable th )
		{
			th.printStackTrace();
			System.exit(1);
		}
	}

	protected static class MainWindowLauncher extends Thread
	{
		protected boolean _exceptionThrown = false;
		protected MainWindow _mainWindow = null;

		public MainWindowLauncher()
		{
			try
			{
				_mainWindow = new MainWindow( );
			}
			catch( Throwable th )
			{
				th.printStackTrace();
				_exceptionThrown = true;
			}
		}
		
		public void run()
		{
			if( ! _exceptionThrown )
			{
				try
				{
					_mainWindow.setVisible(true);
				}
				catch( Throwable th )
				{
					th.printStackTrace();

					_exceptionThrown = true;
				}
			}
		}

		public boolean hasExceptionBeenThrown()
		{
			return( _exceptionThrown );
		}

		public MainWindow getMainWindow()
		{
			return( _mainWindow );
		}
	}

*/
}
